"""empty message

Revision ID: afb044a83b98
Revises: 
Create Date: 2020-02-03 16:38:12.041603

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = 'afb044a83b98'
down_revision = None
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('activity_types',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('name', sa.String(length=64), nullable=False),
    sa.Column('description', sa.String(length=512), nullable=False),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('browser_types',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('name', sa.String(length=64), nullable=False),
    sa.Column('description', sa.String(length=512), nullable=False),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('classnames',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('name', sa.String(length=64), nullable=False),
    sa.Column('description', sa.String(length=512), nullable=False),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('locator_types',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('name', sa.String(length=64), nullable=False),
    sa.Column('description', sa.String(length=512), nullable=False),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('testcase_types',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('name', sa.String(length=64), nullable=False),
    sa.Column('description', sa.String(length=512), nullable=False),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('users',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('username', sa.String(length=64), nullable=False),
    sa.Column('password', sa.String(length=128), nullable=False),
    sa.Column('created', sa.DateTime(), nullable=False),
    sa.Column('lastlogin', sa.DateTime(), nullable=False),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('username')
    )
    op.create_table('datafiles',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('filename', sa.String(length=64), nullable=False),
    sa.Column('created', sa.DateTime(), nullable=False),
    sa.Column('creator_id', sa.Integer(), nullable=False),
    sa.ForeignKeyConstraint(['creator_id'], ['users.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('testcase_sequences',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('name', sa.String(length=64), nullable=False),
    sa.Column('description', sa.String(length=512), nullable=False),
    sa.Column('created', sa.DateTime(), nullable=False),
    sa.Column('creator_id', sa.Integer(), nullable=False),
    sa.Column('edited', sa.DateTime(), nullable=True),
    sa.Column('editor_id', sa.Integer(), nullable=True),
    sa.Column('classname_id', sa.Integer(), nullable=False),
    sa.ForeignKeyConstraint(['classname_id'], ['classnames.id'], ),
    sa.ForeignKeyConstraint(['creator_id'], ['users.id'], ),
    sa.ForeignKeyConstraint(['editor_id'], ['users.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('testcases',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('name', sa.String(length=64), nullable=False),
    sa.Column('description', sa.String(length=512), nullable=False),
    sa.Column('created', sa.DateTime(), nullable=False),
    sa.Column('creator_id', sa.Integer(), nullable=False),
    sa.Column('edited', sa.DateTime(), nullable=True),
    sa.Column('editor_id', sa.Integer(), nullable=True),
    sa.Column('classname_id', sa.Integer(), nullable=False),
    sa.Column('browser_type_id', sa.Integer(), nullable=False),
    sa.Column('testcase_type_id', sa.Integer(), nullable=False),
    sa.ForeignKeyConstraint(['browser_type_id'], ['browser_types.id'], ),
    sa.ForeignKeyConstraint(['classname_id'], ['classnames.id'], ),
    sa.ForeignKeyConstraint(['creator_id'], ['users.id'], ),
    sa.ForeignKeyConstraint(['editor_id'], ['users.id'], ),
    sa.ForeignKeyConstraint(['testcase_type_id'], ['testcase_types.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('testruns',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('name', sa.String(length=64), nullable=False),
    sa.Column('description', sa.String(length=512), nullable=False),
    sa.Column('created', sa.DateTime(), nullable=False),
    sa.Column('creator_id', sa.Integer(), nullable=False),
    sa.Column('edited', sa.DateTime(), nullable=True),
    sa.Column('editor_id', sa.Integer(), nullable=True),
    sa.ForeignKeyConstraint(['creator_id'], ['users.id'], ),
    sa.ForeignKeyConstraint(['editor_id'], ['users.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('teststep_sequences',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('name', sa.String(length=64), nullable=False),
    sa.Column('description', sa.String(length=512), nullable=False),
    sa.Column('created', sa.DateTime(), nullable=False),
    sa.Column('creator_id', sa.Integer(), nullable=False),
    sa.Column('edited', sa.DateTime(), nullable=True),
    sa.Column('editor_id', sa.Integer(), nullable=True),
    sa.Column('classname_id', sa.Integer(), nullable=False),
    sa.ForeignKeyConstraint(['classname_id'], ['classnames.id'], ),
    sa.ForeignKeyConstraint(['creator_id'], ['users.id'], ),
    sa.ForeignKeyConstraint(['editor_id'], ['users.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('global_teststep_executions',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('name', sa.String(length=64), nullable=False),
    sa.Column('description', sa.String(length=512), nullable=False),
    sa.Column('created', sa.DateTime(), nullable=False),
    sa.Column('creator_id', sa.Integer(), nullable=False),
    sa.Column('edited', sa.DateTime(), nullable=True),
    sa.Column('editor_id', sa.Integer(), nullable=True),
    sa.Column('activity_type_id', sa.Integer(), nullable=False),
    sa.Column('locator_type_id', sa.Integer(), nullable=False),
    sa.Column('teststep_sequence_id', sa.Integer(), nullable=True),
    sa.ForeignKeyConstraint(['activity_type_id'], ['activity_types.id'], ),
    sa.ForeignKeyConstraint(['creator_id'], ['users.id'], ),
    sa.ForeignKeyConstraint(['editor_id'], ['users.id'], ),
    sa.ForeignKeyConstraint(['locator_type_id'], ['locator_types.id'], ),
    sa.ForeignKeyConstraint(['teststep_sequence_id'], ['teststep_sequences.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('testcase_sequence_case',
    sa.Column('testcase_sequence_id', sa.Integer(), nullable=False),
    sa.Column('testcase_id', sa.Integer(), nullable=False),
    sa.ForeignKeyConstraint(['testcase_id'], ['testcases.id'], ),
    sa.ForeignKeyConstraint(['testcase_sequence_id'], ['testcase_sequences.id'], ),
    sa.PrimaryKeyConstraint('testcase_sequence_id', 'testcase_id')
    )
    op.create_table('testcase_sequence_datafile',
    sa.Column('testcase_sequence_id', sa.Integer(), nullable=False),
    sa.Column('datafile_id', sa.Integer(), nullable=False),
    sa.ForeignKeyConstraint(['datafile_id'], ['datafiles.id'], ),
    sa.ForeignKeyConstraint(['testcase_sequence_id'], ['testcase_sequences.id'], ),
    sa.PrimaryKeyConstraint('testcase_sequence_id', 'datafile_id')
    )
    op.create_table('testcase_stepsequence',
    sa.Column('testcase_id', sa.Integer(), nullable=False),
    sa.Column('teststep_sequence_id', sa.Integer(), nullable=False),
    sa.ForeignKeyConstraint(['testcase_id'], ['testcases.id'], ),
    sa.ForeignKeyConstraint(['teststep_sequence_id'], ['teststep_sequences.id'], ),
    sa.PrimaryKeyConstraint('testcase_id', 'teststep_sequence_id')
    )
    op.create_table('testrun_casesequence',
    sa.Column('testrun_id', sa.Integer(), nullable=False),
    sa.Column('testcase_sequence_id', sa.Integer(), nullable=False),
    sa.ForeignKeyConstraint(['testcase_sequence_id'], ['testcase_sequences.id'], ),
    sa.ForeignKeyConstraint(['testrun_id'], ['testruns.id'], ),
    sa.PrimaryKeyConstraint('testrun_id', 'testcase_sequence_id')
    )
    op.create_table('teststep_executions',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('name', sa.String(length=64), nullable=False),
    sa.Column('description', sa.String(length=512), nullable=False),
    sa.Column('created', sa.DateTime(), nullable=False),
    sa.Column('creator_id', sa.Integer(), nullable=False),
    sa.Column('edited', sa.DateTime(), nullable=True),
    sa.Column('editor_id', sa.Integer(), nullable=True),
    sa.Column('activity_type_id', sa.Integer(), nullable=False),
    sa.Column('locator_type_id', sa.Integer(), nullable=False),
    sa.Column('teststep_sequence_id', sa.Integer(), nullable=True),
    sa.ForeignKeyConstraint(['activity_type_id'], ['activity_types.id'], ),
    sa.ForeignKeyConstraint(['creator_id'], ['users.id'], ),
    sa.ForeignKeyConstraint(['editor_id'], ['users.id'], ),
    sa.ForeignKeyConstraint(['locator_type_id'], ['locator_types.id'], ),
    sa.ForeignKeyConstraint(['teststep_sequence_id'], ['teststep_sequences.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table('teststep_executions')
    op.drop_table('testrun_casesequence')
    op.drop_table('testcase_stepsequence')
    op.drop_table('testcase_sequence_datafile')
    op.drop_table('testcase_sequence_case')
    op.drop_table('global_teststep_executions')
    op.drop_table('teststep_sequences')
    op.drop_table('testruns')
    op.drop_table('testcases')
    op.drop_table('testcase_sequences')
    op.drop_table('datafiles')
    op.drop_table('users')
    op.drop_table('testcase_types')
    op.drop_table('locator_types')
    op.drop_table('classnames')
    op.drop_table('browser_types')
    op.drop_table('activity_types')
    # ### end Alembic commands ###
